diff --git a/Documentation/_static/logo.png b/Documentation/_static/logo.png
index c2c021bf752ea8d5d1e8d1eabc89b9762d351557..8dfed3b3a3cf29e29b54f467a2f0c69cbaee3adb 100644
GIT binary patch
diff --git a/Documentation/_static/overview.png b/Documentation/_static/overview.png
deleted file mode 100644
index 68948cf21456112aabe00fffed53c99a8c3a5086..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/Documentation/automake.mk b/Documentation/automake.mk
index 2f337532c..ca1fb1222 100644
--- a/Documentation/automake.mk
+++ b/Documentation/automake.mk
@@ -1,7 +1,6 @@
 DOC_SOURCE = \
 	Documentation/group-selection-method-property.txt \
 	Documentation/_static/logo.png \
-	Documentation/_static/overview.png \
 	Documentation/conf.py \
 	Documentation/index.rst \
 	Documentation/contents.rst \
diff --git a/Documentation/conf.py b/Documentation/conf.py
index 2c85dcf4d..c7949b73e 100644
--- a/Documentation/conf.py
+++ b/Documentation/conf.py
@@ -47,9 +47,9 @@ source_suffix = '.rst'
 master_doc = 'contents'

 # General information about the project.
-project = u'Open vSwitch'
-copyright = u'2016, The Open vSwitch Development Community'
-author = u'The Open vSwitch Development Community'
+project = u'OVN'
+copyright = u'2020, The OVN Development Community'
+author = u'The OVN Development Community'

 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
diff --git a/Documentation/contents.rst b/Documentation/contents.rst
index a754bd225..836374806 100644
--- a/Documentation/contents.rst
+++ b/Documentation/contents.rst
@@ -21,9 +21,9 @@

       Avoid deeper levels because they do not render well.

-===================================
-Open vSwitch Documentation Contents
-===================================
+==========================
+OVN Documentation Contents
+==========================

 .. toctree::
    :maxdepth: 3
diff --git a/Documentation/faq/index.rst b/Documentation/faq/index.rst
index 7ad71aabe..d71cf5794 100644
--- a/Documentation/faq/index.rst
+++ b/Documentation/faq/index.rst
@@ -23,9 +23,9 @@

       Avoid deeper levels because they do not render well.

-================
-Open vSwitch FAQ
-================
+=======
+OVN FAQ
+=======

 .. toctree::
    :maxdepth: 2
diff --git a/Documentation/index.rst b/Documentation/index.rst
index c0c6c374d..da396f357 100644
--- a/Documentation/index.rst
+++ b/Documentation/index.rst
@@ -23,14 +23,14 @@

       Avoid deeper levels because they do not render well.

-==========================
-Open vSwitch Documentation
-==========================
+=================
+OVN Documentation
+=================

 How the Documentation is Organised
 ----------------------------------

-The Open vSwitch documentation is organised into multiple sections:
+The OVN documentation is organised into multiple sections:

 - :doc:`Installation guides </intro/install/index>` guide you through
   installing Open vSwitch (OVS) and Open Virtual Network (OVN) on a variety of
@@ -68,10 +68,10 @@ Deeper Dive
   :doc:`intro/install/rhel` |
   :doc:`intro/install/fedora`

-The Open vSwitch Project
-------------------------
+The OVN Project
+---------------

-Learn more about the Open vSwitch project and about how you can contribute:
+Learn more about the OVN project and about how you can contribute:

 - **Community:** :doc:`internals/release-process` |
   :doc:`internals/authors` |
@@ -90,7 +90,7 @@ Learn more about the Open vSwitch project and about how you can contribute:
   :doc:`internals/committer-emeritus-status`

 - **Documentation:** :doc:`internals/contributing/documentation-style` |
-  :doc:`Building Open vSwitch Documentation <intro/install/documentation>` |
+  :doc:`Building OVN Documentation <intro/install/documentation>` |
   :doc:`internals/documentation`

 Getting Help
diff --git a/Documentation/ref/index.rst b/Documentation/ref/index.rst
index 7ff9edd09..ecb181c6f 100644
--- a/Documentation/ref/index.rst
+++ b/Documentation/ref/index.rst
@@ -49,42 +49,42 @@ The remainder are still in roff format can be found below:
 .. list-table::

    * - ovn-architecture(7)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-architecture.7.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-architecture.7.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-architecture.7.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-architecture.7.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-architecture.7.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-architecture.7.txt>`__
    * - ovn-controller(8)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-controller.8.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-controller.8.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-controller.8.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-controller.8.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-controller.8.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-controller.8.txt>`__
    * - ovn-controller-vtep(8)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-controller-vtep.8.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-controller-vtep.8.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-controller-vtep.8.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-controller-vtep.8.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-controller-vtep.8.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-controller-vtep.8.txt>`__
    * - ovn-ctl(8)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-ctl.8.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-ctl.8.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-ctl.8.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-ctl.8.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-ctl.8.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-ctl.8.txt>`__
    * - ovn-nb(5)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-nb.5.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-nb.5.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-nb.5.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-nb.5.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-nb.5.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-nb.5.txt>`__
    * - ovn-nbctl(8)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-nbctl.8.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-nbctl.8.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-nbctl.8.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-nbctl.8.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-nbctl.8.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-nbctl.8.txt>`__
    * - ovn-northd(8)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-northd.8.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-northd.8.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-northd.8.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-northd.8.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-northd.8.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-northd.8.txt>`__
    * - ovn-sb(5)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-sb.5.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-sb.5.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-sb.5.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-sb.5.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-sb.5.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-sb.5.txt>`__
    * - ovn-sbctl(8)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-sbctl.8.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-sbctl.8.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-sbctl.8.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-sbctl.8.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-sbctl.8.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-sbctl.8.txt>`__
    * - ovn-trace(8)
-     - `(pdf) <http://www.openvswitch.org/support/dist-docs/ovn-trace.8.pdf>`__
-     - `(html) <http://www.openvswitch.org/support/dist-docs/ovn-trace.8.html>`__
-     - `(plain text) <http://www.openvswitch.org/support/dist-docs/ovn-trace.8.txt>`__
+     - `(pdf) <http://www.ovn.org/support/dist-docs/ovn-trace.8.pdf>`__
+     - `(html) <http://www.ovn.org/support/dist-docs/ovn-trace.8.html>`__
+     - `(plain text) <http://www.ovn.org/support/dist-docs/ovn-trace.8.txt>`__
diff --git a/build-aux/xml2nroff b/build-aux/xml2nroff
index bd4e87928..71a383e07 100755
--- a/build-aux/xml2nroff
+++ b/build-aux/xml2nroff
@@ -77,7 +77,7 @@ def manpage_to_nroff(xml_file, subst, include_path, version=None):
     # needs to be preprocessed by "pic".
     s = r''''\" p
 .\" -*- nroff -*-
-.TH "%s" %s "%s" "Open vSwitch %s" "Open vSwitch Manual"
+.TH "%s" %s "%s" "OVN %s" "OVN Manual"
 .fp 5 L CR              \\" Make fixed-width font available as \\fL.
 .de TQ
 .  br
diff --git a/utilities/ovn-detrace.1.in b/utilities/ovn-detrace.1.in
index b899b632c..6790afdc4 100644
--- a/utilities/ovn-detrace.1.in
+++ b/utilities/ovn-detrace.1.in
@@ -1,5 +1,5 @@
 .so lib/ovs.tmac
-.TH ovn\-detrace 1 "@VERSION@" "Open vSwitch" "Open vSwitch Manual"
+.TH ovn\-detrace 1 "@VERSION@" "OVN" "OVN Manual"
 .
 .SH NAME
 ovn\-detrace \- convert ``ovs\-appctl ofproto/trace'' output to combine
diff --git a/utilities/ovn-sbctl.8.in b/utilities/ovn-sbctl.8.in
index d9fc3a57c..153e72e6c 100644
--- a/utilities/ovn-sbctl.8.in
+++ b/utilities/ovn-sbctl.8.in
@@ -1,6 +1,6 @@
 .\" -*- nroff -*-
 .so lib/ovs.tmac
-.TH ovn\-sbctl 8 "@VERSION@" "Open vSwitch" "Open vSwitch Manual"
+.TH ovn\-sbctl 8 "@VERSION@" "OVN" "OVN Manual"
 .\" This program's name:
 .ds PN ovn\-sbctl
 .